import javax.faces.context.FacesContext;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;
import javax.servlet.http.HttpServletRequest;
import java.util.*;

public class AuthenticationPhaseListener
  implements PhaseListener
{
  public void afterPhase(PhaseEvent event)
  {
    FacesContext context = event.getFacesContext();

    if (!authorizePage(context) && loggedIn(context))
    {
      context.responseComplete();
      context.getApplication().getNavigationHandler().handleNavigation(context, null, "AlreadyLoggedIn");
    }
    else if (authorizePage(context) && !loggedIn(context))
    {
      context.responseComplete();
      context.getApplication().getNavigationHandler().handleNavigation(context, null, "LoginRequired");
    }
  }

  public void beforePhase(PhaseEvent event)
  {}

  public PhaseId getPhaseId()
  {
    return PhaseId.RESTORE_VIEW;
  }

  private boolean loggedIn(FacesContext context)
  {
    beans.User user = (beans.User)context.getExternalContext().getSessionMap().get("user");
    if (user == null)
      return false;
    return user.getLoggedIn();
  }

  private boolean authorizePage(FacesContext context)
  {
    List<String> publicpages = new ArrayList<String>();
    publicpages.add("/login.xhtml");
    publicpages.add("/register.xhtml");

    HttpServletRequest request = (HttpServletRequest)context.getExternalContext().getRequest();
    String uri = request.getRequestURI();
    if (uri == null)
      return false;

    boolean found = false;
    for(String page : publicpages)
    {
      if (uri.equals(request.getContextPath() + "/") || uri.startsWith(request.getContextPath() + page))
      {
        found = true;
        break;
      }
    }
    return !found;
  }
}
