package beans;

import java.util.*;
import java.text.*;
import java.lang.Math;

public class MemorySession
{
  private Date startTime;
  private int attempts = 0;
  private int foundPairs = 0;
  private MemoryCard[] cards = null;
  private MemoryCard firstCard = null;

  public MemorySession(int cntcards)
  {
    startTime = new Date();
    cards = new MemoryCard[cntcards];
    for (int i = 0; i < cntcards; ++i)
      cards[i] = new MemoryCard();
  }

  /*--------------------------------------------------------------------------*/

  public int getTotalCards()
  {
    return cards.length;
  }

  /*--------------------------------------------------------------------------*/

  public int getBoardWidth()
  {
    return (int)Math.ceil(Math.sqrt(getTotalCards()));
  }

  /*--------------------------------------------------------------------------*/

  public MemoryCard getCard(int ix)
  {
    return cards[ix];
  }

  /*--------------------------------------------------------------------------*/

  public Date getStartTime()
  {
    return startTime;
  }

  /*--------------------------------------------------------------------------*/

  public Date getElapsedTime()
  {
    SimpleDateFormat dateFormat = new SimpleDateFormat("mm:ss");
    dateFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
    long currentTime = Calendar.getInstance().getTimeInMillis();
    return new Date(currentTime - getStartTime().getTime());
  }

  /*--------------------------------------------------------------------------*/

  public int getAttempts()
  {
    return attempts;
  }

  public void incAttempts()
  {
    ++attempts;
  }

  /*--------------------------------------------------------------------------*/

  public int getFoundPairs()
  {
    return foundPairs;
  }

  public void incFoundPairs()
  {
    ++foundPairs;
  }

  /*--------------------------------------------------------------------------*/

  public MemoryCard getFirstCard()
  {
    return firstCard;
  }

  public void setFirstCard(MemoryCard firstCard)
  {
    this.firstCard = firstCard;
  }

  /*--------------------------------------------------------------------------*/

  public void handleCardClick(MemoryCard card)
  {
    ewa.Memory.handleCardClick(this, card);
  }
}
