package beans;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;

import java.util.Date;
import java.util.ResourceBundle;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlSelectBooleanCheckbox;
import javax.faces.event.ValueChangeEvent;
import javax.faces.validator.ValidatorException;
import javax.faces.context.FacesContext;
import javax.faces.context.ExternalContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.ServletException;

@ManagedBean(name = "user")
@SessionScoped
public class User
{
  private String username;
  private String password;
  private boolean additionalData = false;
  private boolean loggedIn = false;

  private Date birth;
  private String firstname;
  private String surename;
  private String gender;
  private int stacksize;

  /*--------------------------------------------------------------------------*/

  public User()
  {}

  /*--------------------------------------------------------------------------*/

  public void setUsername(String username)
  {
    this.username = username;
  }

  public String getUsername()
  {
    return username;
  }

  /*--------------------------------------------------------------------------*/

  public void setPassword(String password)
  {
    this.password = password;
  }

  public String getPassword()
  {
    return password;
  }

  /*--------------------------------------------------------------------------*/

  public void setFirstname(String firstname)
  {
    this.firstname = firstname;
  }

  public String getFirstname()
  {
    return firstname;
  }

  /*--------------------------------------------------------------------------*/

  public void setSurename(String surename)
  {
    this.surename = surename;
  }

  public String getSurename()
  {
    return surename;
  }

  /*--------------------------------------------------------------------------*/

  public void setGender(String gender)
  {
    this.gender = gender;
  }

  public String getGender()
  {
    return gender;
  }

  /*--------------------------------------------------------------------------*/

  public void setStacksize(int stacksize)
  {
    this.stacksize = stacksize;
  }

  public int getStacksize()
  {
    return stacksize;
  }

  /*--------------------------------------------------------------------------*/

  public void setAdditionalData(boolean additionalData)
  {
    this.additionalData = additionalData;
  }

  public boolean getAdditionalData()
  {
    return additionalData;
  }

  /*--------------------------------------------------------------------------*/

  public void setLoggedIn(boolean loggedIn)
  {
    this.loggedIn = loggedIn;
  }

  public boolean getLoggedIn()
  {
    return loggedIn;
  }

  /*--------------------------------------------------------------------------*/

  public void setBirth(Date birth)
  {
    this.birth = birth;
  }

  public Date getBirth()
  {
    return birth;
  }

  /*--------------------------------------------------------------------------*/

  public boolean equals(User other)
  {
    return (username.equals(other.username)) ? true : false;
  }

  /*--------------------------------------------------------------------------*/

  public void toggleAdditionalData(ValueChangeEvent e)
  {
    Boolean show = (Boolean)e.getNewValue();
    if (show != null)
      additionalData = show;
    FacesContext.getCurrentInstance().renderResponse();
  }

  /*--------------------------------------------------------------------------*/

  public void validatePassword(FacesContext context, UIComponent toValidate, Object value)
    throws ValidatorException
  {
    String password = (String)value;
    ResourceBundle bundle = ResourceBundle.getBundle("locale.memory", FacesContext.getCurrentInstance().getViewRoot().getLocale());
    String msg = null;
    if (password.length() < 8)
      msg = bundle.getString("register_password_tooshort");
    else if (!utils.Strings.hasLetter(password) || !utils.Strings.hasNumber(password))
      msg = bundle.getString("register_password_notsecure");

    if (msg != null)
      throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, msg, null));
  }
  
  /*--------------------------------------------------------------------------*/

  public String newGame()
    throws ServletException
  {
    FacesContext fcontext = FacesContext.getCurrentInstance();
    ExternalContext econtext = fcontext.getExternalContext();
    HttpServletRequest request = (HttpServletRequest)econtext.getRequest();
    beans.MemorySession memSession = new beans.MemorySession(getStacksize());
    ewa.Memory.dealCards(memSession, "resources/img/card_images");
    request.getSession(true).setAttribute("memSession", memSession);

    fcontext.responseComplete();
    fcontext.getApplication().getNavigationHandler().handleNavigation(fcontext, null, "NewGame");
    return "/table.xhtml";
  }
}
