package beans;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ApplicationScoped;
import java.util.ArrayList;

import java.util.ResourceBundle;
import javax.faces.context.FacesContext;
import javax.faces.application.FacesMessage;
import javax.servlet.http.HttpSession;

@ManagedBean(name = "userdb")
@ApplicationScoped
public class UserDB
{
  ArrayList<User> users = new ArrayList<User>();

  /*--------------------------------------------------------------------------*/

  public UserDB()
  {}

  /*--------------------------------------------------------------------------*/

  public boolean add(User user)
  {
    if (search(user) != null)
      return false;
    users.add(user);
    return true;
  }

  /*--------------------------------------------------------------------------*/

  public String register(User user)
  {
    if (add(user))
    {
      // remove user bean from session
      // as this is a reference a new registration will edit the object in the database
      FacesContext.getCurrentInstance().getExternalContext().getSessionMap().remove("user");
      return "/register_ok.xhtml";
    }
    else
    {
      ResourceBundle bundle = ResourceBundle.getBundle("locale.memory", FacesContext.getCurrentInstance().getViewRoot().getLocale());
      String msg = bundle.getString("register_duplicate");
      FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, msg, null));
      return null;
    }
  }

  /*--------------------------------------------------------------------------*/

  public String login(User user)
  {
    User found = search(user);
    if (found == null || !found.getPassword().equals(user.getPassword()))
    {
      ResourceBundle bundle = ResourceBundle.getBundle("locale.memory", FacesContext.getCurrentInstance().getViewRoot().getLocale());
      String msg = bundle.getString("login_invalid");
      FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, msg, null));
      return null;
    }
    user.setLoggedIn(true);
    FacesContext.getCurrentInstance().responseComplete();
    FacesContext.getCurrentInstance().getApplication().getNavigationHandler().handleNavigation(FacesContext.getCurrentInstance(), null, "AlreadyLoggedIn");
    return "/lobby.xhtml";
  }

  /*--------------------------------------------------------------------------*/

  public String logout(User user)
  {
    if (user != null)
    {
      user.setLoggedIn(false);
      FacesContext.getCurrentInstance().getExternalContext().getSessionMap().remove("user");
    }
    HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(false);
    if (session != null)
      session.invalidate();
    FacesContext.getCurrentInstance().responseComplete();
    FacesContext.getCurrentInstance().getApplication().getNavigationHandler().handleNavigation(FacesContext.getCurrentInstance(), null, "LoginRequired");
    return "/login.xhtml";
  }

  /*--------------------------------------------------------------------------*/

  public User search(User newuser)
  {
    User found = null;
    for (User user : users)
    {
      if (user.equals(newuser))
      {
        found = user;
        break;
      }
    }
    return found;
  }
}
