package ewa;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.RequestDispatcher;

import beans.*;
import java.util.*;

public class Memory
{
  public static void dealCards(MemorySession memSession, String path)
    throws ServletException
  {
    /* TODO: images should be read from filessystem (doesn't work with .war)
     *       or some database
     */
    List<String> imagelist = new ArrayList<String>();
    for (int i = 1; i <= 18; ++i)
      imagelist.add("card" + i + ".jpg");
    if (imagelist.size() * 2 < memSession.getTotalCards())
      throw new ServletException("Not enough cards available");

    Collections.shuffle(imagelist);

    for (int i = imagelist.size(); i > memSession.getTotalCards() / 2; --i)
      imagelist.remove(i - 1);

    imagelist.addAll(imagelist);

    Collections.shuffle(imagelist);

    for (int i = 0; i < memSession.getTotalCards(); ++i)
      memSession.getCard(i).setImageUrl(path + "/" + imagelist.get(i));
  }

  /*--------------------------------------------------------------------------*/

  public static void handleCardClick(MemorySession memSession, String idparam)
  {
    if (idparam == null)
      return;

    int cardid = 0;
    try
    {
      cardid = Integer.parseInt(idparam);
    }
    catch(NumberFormatException ex)
    {
      return;
    }

    if (cardid < 0 || cardid >= memSession.getTotalCards())
      return;

    handleCardClick(memSession, memSession.getCard(cardid));
  }

  /*--------------------------------------------------------------------------*/

  public static void handleCardClick(MemorySession memSession, MemoryCard card)
  {
    if (card.isFound())
      return;

    if (memSession.getFirstCard() == null)
    {
      /* erste karte wird aufgedeckt. decke alle anderen karten zu */
      for (int i = 0; i < memSession.getTotalCards(); ++i)
        memSession.getCard(i).setFlipped(false);
      card.setFlipped(true);
      memSession.setFirstCard(card);
    }
    else if (memSession.getFirstCard() == card)
    {
      /* karte wieder zudecken  */
      card.setFlipped(false);
      memSession.incAttempts();
      memSession.setFirstCard(null);
    }
    else
    {
      /* zweite karte wird aufgedeckt */
      if (memSession.getFirstCard().getImageUrl().equals(card.getImageUrl()))
      {
        /* paar wurde gefunden */
        memSession.getFirstCard().setFound(true);
        card.setFound(true);
        memSession.incFoundPairs();
      }
      else
      {
        /* paar wurde nicht gefunden */
        card.setFlipped(true);
        memSession.incAttempts();
      }
      memSession.setFirstCard(null);
    }
  }
}
